; CanDb1.TXT = Testprogramm fuer "UPT"-Entwicklung  mit   "CANdb-Signalen" .
;  Ablage: <WoBu3> C:\CBproj\CanTest\Programs\CanDb1.TXT .
;  Stand:  2003-03-10 (YYYY-MM-DD)
;    ERSETZT irgendein ominoeses Geraet welches CAN-"MESSAGES" nach "CAN-DB-Format"
;    sendet.
;    Lauffaehig nur mit WoBu's experimentellem CAN-Tester fuer WINDOZE ab Januar 2002 !!
;  Fuer MKT-View und verschiedene *.cvt - Testdateien (siehe Unten !)... u.A.
;   -  "C:\CBproj\UptWin1\Programs\mux_test.CVT" 


@gosub SetWatches

@goto MuxTest

; Some "CANdb test signals" .. don't ask where they come from ;-)
; "TOEL": Bus1, ID=0x0000D3, MOTOROLA, 16 bit, LSB at bit 39??????!?!?!??????!??!?

@N=0:@H=0
L1:  ;-- emulate some "CAN db" - messages with (N) signals....... holy shit
 ; $0000C 01 02 03 04 05 06 07 08 
 $000D3 (H).mw (H).mw (H).mw (H).mw  ; Suffix ".mw" = MOTOROLA word (MSB first)
 @N=N+1:@H=H+10
@goto L1


; CAN-ID 0x0D3 enthaelt vier 116-bit Signale im MOTOROLA-FORMAT (MSB first):
;              TL_0,    TL_1RS,      TOEL,    TKW .
;              Faktor: 0.019, Offset: 575.01,  Min=-50, Max=1200, Einheit=C
$00D3 (     0).mw (     0).mw (     0).mw (     0).mw   ; ->  "575.01 C" (?)
$00D3 (     1).mw (     1).mw (     1).mw (     1).mw   ; ->  "575.03 C" (?)
$00D3 (   100).mw (   100).mw (   100).mw (   100).mw   ; ->  "576.92 C" (?!)
$00D3 ( $8000).mw ( $8000).mw ( $8000).mw ( $8000).mw   ; ->  "-50.00 C" 
$00D3 ( $FFFF).mw ( $FFFF).mw ( $FFFF).mw ( $FFFF).mw   ; ->  "574.99 C" 
$00D3 (-30147).mw (-30147).mw (-30147).mw (-30147).mw   ; ->  " -0.01 C"
L2:
 $00D3 (T).mw (T).mw (T).mw (T-10000).mw         ; TL_0,   TL_1RS, TOEL,   TKW
 $00DE (T).mw (T).mw (-29000+(T/100)).mw (T).mw  ; T_vUBK, T_nUBK, TL_amb, Thermo2_8
 @T=(T+1000) & $0FFFF
@goto L2

; CAN-BUS #2 ( NUMERO DUE !! ),  CAN-ID #1365 = 0x0555 .....
;              enthaelt ein 14-bit(!) Signal im MOTOROLA-FORMAT (MSB first)
;              aus einem Beispiel in VEKTOR's CANdb++ EDITOR HELP SYSTEM.
;              Das LEAST SIGNIFICANT BIT liegt an Bitposition 21 im CAN-Telegramm,
;              das MOST  SIGNIFICANT BIT liegt an Bitposition  4 (!) .
;       Das ekelhafte Kuddelmuddel dieses auf DREI BYTES(!) verteilten 14-bit(!)-Signals
;       kann per CAN-Tester kaum nachgebildet werden, darum einzelne Telegramme:       
;           Das MSBit an Position 23, wird bei Vektor irrefuehrenderweise 
;                                        "Startposition" genannt .
;           KVASER meint, statt Bitposition 23 lieber "Start Bit 47" sagen zu muessen - shit.
;       Siehe Bildschirmhardcopy von Kvaser's "Navigator Database Editor", 
;       Datei c:/CBProj/UptWin1/Programs/test5.dbc . 
;       Signalname "m14_msb23", Messagename "Vector_Demo_Motorola".
$00555 E0 00 7F FF FF FF FF FF  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : muss 0 ergeben
$00555 FF FF FF FF FF FF FF FF  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : muss -1 ergeben
$00555 1F FF 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : ebenfalls -1
$00555 00 00 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 1 
$00555 00 01 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 2
$00555 00 02 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 4
$00555 00 04 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 8
$00555 00 80 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 256
$00555 01 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 512
$00555 02 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 1024
$00555 04 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 2048
$00555 08 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 4096
$00555 10 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> -(!) 8192
$00555 0F FF 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit LSBit-Pos 23 : -> 8191
L3:
 $00555 (T).mw
 @T=T+5
@goto L3

; CAN-BUS #2 ( NUMERO DUE !! ),  CAN-ID #1366 = 0x0556 .....
;              enthaelt ein 14-bit(!) Signal im INTEL-FORMAT (LSB first)
;              aus einem Beispiel in VEKTOR's CANdb++ EDITOR HELP SYSTEM.
;              Das LEAST SIGNIFICANT BIT liegt an Bitposition  3 im CAN-Telegramm,
;              das MOST  SIGNIFICANT BIT liegt an Bitposition 16 (!) .
;           KVASER meint, "Start Bit 3" sagen zu muessen - bei Intel-Format
;                  entspricht dies dem LEAST SIGNIFICANT BIT,
;                  und die Bitzaehlung im Telegramm beginnt bei "0" (erstes Byte, Bit0).
;           WoBu meint, dieses "Startbit" lieber "Position vom LSB" zu nennen,
;                  da dies die Sache klarer macht (bei vielen Bussen/Schnittstellen
;                  hat "Startbit" eine klare funktionelle Bedeutung !!!)
;       Siehe Bildschirmhardcopy von Kvaser's "Navigator Database Editor", 
;       Datei c:/CBProj/UptWin1/Programs/test5.dbc . 
;       Signalname "i14_lsb3", Messagename "Vector_Demo_Intel".
$00556 03 00 FE FF FF FF FF FF  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : muss 0 ergeben
$00556 FF FF FF FF FF FF FF FF  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : muss -1 ergeben
$00556 F8 FF 01 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : ebenfalls -1
$00556 08 00 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 1 
$00556 10 00 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 2
$00556 00 10 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 512
$00556 00 20 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 1024
$00556 00 40 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 2048
$00556 00 80 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 4096
$00556 00 00 01 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> -(!) 8192
$00556 F8 FF 00 00 00 00 00 00  ; 14-Bit INTEL-Integer mit LSBit-Pos 3 : -> 8191


; Andere CAN-Telegramme, die beim Testen des "CANdb-Terminals" irgendwo/irgendwann
;        gebraucht wurden. 
;    Siehe z.B. "\\WoBu3\c\cbproj\UptWin1\programs\cdb_test1.cvt" (2002-10-09)
$07FF.s 01 02 03 04 05 06 07 08
$07FF.x 01 02 03 04 05 06 07 08
$000 01 02 03 04
$601 00 00 00 00

;  Fuer Terminal-Applikation "\\WoBu3\c\cbproj\UptWin1\programs\mux_test.cvt"    (2003-03-10)
;   Byte[0] im Telegramm mit CANid=0x007B ist der "Multiplexor" fuer Byte[1] :
MuxTest:
$007B.s 00 41 00 00 00 00 00 00  ; Bus1, "Terminal.MuxedMsg.PrintedChars"  = 'A' (2003-03-10)
$007B.s 00 42 00 00 00 00 00 00  ; Bus1, "Terminal.MuxedMsg.PrintedChars"  = 'B' (2003-03-10)
$007B.s 00 43 00 00 00 00 00 00  ; Bus1, "Terminal.MuxedMsg.PrintedChars"  = 'C' (2003-03-10)
$007B.s 01 1B 00 00 00 00 00 00  ; Bus1, "Terminal.MuxedMsg.TerminalCommand"=#27 (2003-03-10)
@goto MuxTest


;  Fuer Terminal-Applikation "\\WoBu3\c\cbproj\UptWin1\programs\cdb_test1.cvt"   (2002-10-09)
$0182.s 00 00 00 00 00 00 00 00  ; Bus1, "CanOpenIO.PDO2_DI.DigIn0" ... "DigIn7" (2002-10-09)
$0182.s 55 00 00 00 00 00 00 00  ; Bus1, "CanOpenIO.PDO2_DI.DigIn0" ... "DigIn7" (2002-10-09)
$0182.s AA 00 00 00 00 00 00 00  ; Bus1, "CanOpenIO.PDO2_DI.DigIn0" ... "DigIn7" (2002-10-09)
L:
$0182.s (N) 00 00 00 00 00 00 00
@N=N+1
@goto L

$0555.s 11 22 33 44 55 66 77 88  ; Bus1, "WoBu.Vector_Demo.m14_msb23" -> M14_msb23
$0556.s 88 77 66 55 44 33 22 11  ; ...
$0000.s 00 00                    ; "NMT_Master.NMT_0.NodeID" und "CmdSpec"


; Fuer Terminal-Applikation "BMW_HORST.CVT"  (2003-09-19)
BMW_Horst:
$615.s 01 02 03 04    05  06 (N).iw    ; diverse Anzeigeparameter
$613.s (N).iw 00  00  00  00  00  00   ; Kilometerstand
$545.s 02 (N).iw 00   (N).b 02 02 02   ; Verbrauch(uL), Oeltemperatur
$329.s 00 (N) 00 00   00  00  00  00   ; T_MOT (*0.75 C)
$316.s 00 00  (N).iw  00  00  00  00   ; N_MOT (*0.15625 1/min)
$153.s (N).b 00 (N).iw  00  00  00  00   ; S_BLS, V1 (??)
@N=N+1
@goto BMW_Horst


;---------- some "watches" ---------------------------------------------------
SetWatches:
@return
@def_watch(1).name  SDO-Write CH1
@def_watch(1).event (#1538) 0 8 2B xx xx xx xx xx xx xx
@def_watch(1).expr  hl(rx.d1, rx.d0)  ; 16 - bit  Index
@def_watch(1).format U=%ld
@def_watch(1).action a
@set_scope(1).range -32768, 32768       ; Scope-Messbereich passend zur Watch

@def_watch(2).name  SDO-Write CH2
@def_watch(2).event (#1539) 0 8 2B xx xx xx xx xx xx xx
@def_watch(2).expr  hl(rx.d1, rx.d0)  ; 16 - bit  Index
@def_watch(2).format U=%ld
@def_watch(2).action @sound(100,200,5)
@set_scope(2).range -32768, 32768       ; Scope-Messbereich passend zur Watch

@return

