;---- KWP / TP - Simulator (Anweisungsdatei fr CAN-Tester) :  CLIENT ------
; (Ersetzt ein DIAGNOSEGERT; keine ECU ! Basiert auf 20060327_Beispiel_KWP.asc,
;  hat aber nicht direkt mit KWP sondern eher mit ISO15765-2 zu tun (nicht -4!).
;
; Programm starten mit F9 bzw. "Run"..."Start"  !
;
; Autor: Wolfgang Buescher     Stand: 2006-03-31
;   Ablage des Originals: //WoBu3/c/CBproj/CanTest/Programs/KWP_TP_Sim_Client.txt .
;
; Weitere Infos: Siehe SERVER-SIMULATION !
@tx_interval = 0.01      ; Ablaufgeschwindigkeit einstellen
ClearScreen(1)           ; RX-Fenster (blau) lschen

ClientCycle:

Read4E0:    ; Ablauf strikt nach 20060327_Beispiel_KWP.asc !
4E0         02 21 05 00 00 00 00 00   ; Anfordern von IRGENDWAS per "Single Frame" (N_PCItype=0)
wcan 5FF  8 10 13 xx xx xx xx xx xx   ; Auf "First Frame" warten    (N_PCItype=1), N_Data egal!
4E0         30 08 28 00 00 00 00 00   ; "FlowControl" senden        (N_PCItype=3)
wcan 5FF  8 21 xx xx xx xx xx xx xx   ; warten auf "Consecutive Frame" (N_PCItype=2, SN=1)
wcan 5FF  8 22 xx xx xx xx xx xx XX   ; noch ein "Consecutive Frame"   (N_PCItype=2, SN=2) 
4E0         02 1A 87 00 00 00 00 00   ; Anfordern von IRGENDWAS ANDEREM (SF.. siehe oben)
wcan 5FF  8 10 16 xx xx xx xx xx xx   ; "First Frame" abwarten (naja, eigentlich second frame)
4E0         30 08 28 00 00 00 00 00   ; FlowControl senden
wcan 5FF  8 21 xx xx xx xx xx xx xx   ; drei CF's (SN=1..3)
wcan 5FF  8 22 xx xx xx xx xx xx xx   ; ..
wcan 5FF  8 23 xx xx XX XX XX XX XX   ; insgesamt 0x16 = 22 bytes, 5 dummies
4E0         04 18 02 FF 00 00 00 00   ; Nchste Anforderung per "Single Frame" mit 4(!) Bytes
wcan 5FF  8 02 xx xx XX XX XX XX XX   ; Antwort AUCH EIN "Single Frame", mit 2(!) Nutzdatenbytes
4E0         02 21 70 00 00 00 00 00   ; Nchste Anforderung per SF mit 2(!) Bytes
wcan 5FF  8 10 27 xx xx xx xx xx xx   ; Antwort "First Frame", 12-bit FF_DL = 0x27, + 6 N_Datas
4E0         30 08 28 00 00 00 00 00   ; "FlowControl" senden        (N_PCItype=3)
wcan 5FF  8 21 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #1 abwarten
wcan 5FF  8 22 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #2 abwarten
wcan 5FF  8 23 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #3 abwarten
wcan 5FF  8 24 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #4 abwarten
wcan 5FF  8 25 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #5 abwarten
; das war's von ECU-ID 4E0/5FF . Weiter geht's mit dem nchsten Steuergert (ECU).

Read7E0:
7E0         02 1A 87 00 00 00 00 00   ; Anforderung Softwareversionen (KWP?)
wcan 7E8  8 10 16 xx xx xx xx xx xx   ; "First Frame" (FF) abwarten
7E0         30 08 28 00 00 00 00 00   ; "Flow Control" (FC) senden
wcan 7E8  8 21 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #1 abwarten
wcan 7E8  8 22 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #2 abwarten
wcan 7E8  8 23 xx xx xx xx xx xx xx   ; "Consecutive Frame" (CF) #3 abwarten
7E0         04 18 02 FF 00 00 00 00   ; Anforderung von irgendwas anderem..
wcan 7E8  8 02 xx xx xx xx xx xx xx   ; ..was als SingleFrame beantwortet wird

Read7E1:
7E1         02 1A 87 00 00 00 00 00   ; Abfrage per SF
wcan  7E9 8 10 16 xx xx xx xx xx xx   ; Antwort als FF
7E1         30 08 28 00 00 00 00 00   ; Sende FC
wcan 7E9  8 21 xx xx xx xx xx xx xx   ; Warte auf CF #1
wcan 7E9  8 22 xx xx xx xx xx xx xx   ; Warte auf CF #2
wcan 7E9  8 23 xx xx xx xx xx xx xx   ; Warte auf CF #3
7E1         04 18 02 FF 00 00 00 00   ; Abfrage per SF
wcan 7E9  8 02 xx xx XX XX XX XX XX   ; Antwort als SF

Read784:
784         02 1A 87 00 00 00 00 00
wcan 785  8 03 xx xx xx XX XX XX XX
wcan 785  8 10 16 xx xx xx xx xx xx
784         30 08 28 00 00 00 00 00
wcan 785  8 21 xx xx xx xx xx xx xx
wcan 785  8 22 xx xx xx xx xx xx xx
wcan 785  8 23 xx xx xx xx xx xx xx
784         04 18 02 FF 00 00 00 00
wcan 785  8 02 xx xx XX XX XX XX XX

Read788:
788         02 1A 87 00 00 00 00 00
wcan 789  8 10 16 xx xx xx xx xx xx
788         30 08 28 00 00 00 00 00
wcan 789  8 21 xx xx xx xx xx xx xx
wcan 789  8 22 xx xx xx xx xx xx xx
wcan 789  8 23 xx xx xx xx xx xx xx
788         04 18 02 FF 00 00 00 00
wcan 789  8 02 xx xx 00 00 00 00 00

Read792:
792         02 1A 87 00 00 00 00 00
wcan 793  8 10 16 xx xx xx xx xx xx
792         30 08 28 00 00 00 00 00
wcan 793  8 21 xx xx xx xx xx xx xx
wcan 793  8 22 xx xx xx xx xx xx xx
wcan 793  8 23 xx xx xx xx xx xx xx
792         04 18 02 FF 00 00 00 00
wcan 793  8 02 xx xx 00 00 00 00 00


;@sound( 10, 200, 50 )
@delay(1)   ; kurz warten, und das Ganze wiederholen
@goto ClientCycle


; <EOF>


